import os
import json
import pickle


def resolve_experiment_id(models_dir):
    """
    Return the ID of the next experiment.

    The ID is an int equal to n+1 where n is the current number of directory in `models_dir
    `
    :param models_dir:
    :return:
    """
    ids = [x for x in os.listdir(models_dir) 
        if os.path.isdir(models_dir + os.sep + x)]
    if len(ids) > 0:
        return int(max([int(i) for i in ids])) + 1
    return 1

def save_obj_to_json(file_path, attributes_dict):
    attributes = dict()
    for key, value in attributes_dict.items():
        attributes[key[1:]] = value
    with open(file_path, 'w') as output_file:
        json.dump(
            attributes,
            output_file,
            indent=4
        )

def load_obj_from_json(file_path, constructor):
    with open(file_path, 'r') as input_file:
        parameters = json.load(input_file)
    return constructor(**parameters)

def save_obj_to_pickle(file_path, attributes_dict):
    attributes = dict()
    for key, value in attributes_dict.items():
        attributes[key[1:]] = value
    with open(file_path, 'wb') as output_file:
        pickle.dump(attributes, output_file)

def load_obj_from_pickle(file_path, constructor):
    with open(file_path, 'rb') as input_file:
        parameters = pickle.load(input_file)
    return constructor(**parameters)
